
CLEN = 17

GSZFileName db  "C:\DOS\GSZ.EXE",0
UpParams    dw  0,offset UpCmdTail, seg UpCmdTail, 0,0,0,0
DNParams    dw  0,offset DownCmdTail, seg DownCmdTail, 0,0,0,0

UPCMDtail   db  CLEN
            db  " port 2 sz -m -r "
FileName    db  130 dup (0)

DOWNCMDtail db  CLEN                  ;length of cmd tail (dont count CR)
            db  " port 2 rz -m -r "
            db  13

SaveSPSS    dd  ?

MSG_Upload  db  "UPLOAD FILE:",13,10,"Please enter filename: $"
MSG_DownLoad db "DOWNLOAD FILE:",13,10,"$"

MSG_UploadF  db  13,10,10,"UPLOAD FINISHED",13,10,"Back in terminal mode.$"
MSG_DownLoadF db 13,10,10,"DOWNLOAD FINISHED",13,10,"Back in terminal mode.$"

KeyInputBuffer db 60,?,61 dup (0)

    
    ; Executes a file
    ;
    ; IN: DS:DX = ptr to the filename to execute
    ;     ES:BX = ptr to the Parameters
    ;
    ;OUT: AL = Return code of subfunction
    
PROC CallExec NEAR
    pusha
    push    ds es
    pushf
    
    mov     [WORD HIGH cs:SaveSPSS],SS
    mov     [WORD LOW  cS:SaveSPSS],SP

    mov     ax,4b00h
    int     21h

    cli
  ;  lss     sp,[cs:SaveSPSS]
    
    mov     ss,[WORD HIGH cs:SaveSPSS]
    mov     sp,[WORD LOW  cS:SaveSPSS]
    
    sti

    popf
    pop     es ds
    popa
    ret
ENDP CallExec

    
    ;Prompts for a filename and then tries to upload the file
    
PROC UpLoad NEAR
    pusha    
    push    ds es

    mov     bx,cs
    mov     es,bx
    mov     ds,bx

    mov     dx,offset MSG_UPLOAD
    mov     ah,9
    int     21h

    mov     ah,0ah              ;buffered keyboard input
    mov     dx,offset KeyInputBuffer
    int     21h

    mov     si,offset KeyInputBuffer + 2
    mov     di,offset FileName
    mov     cl,[KeyInputBuffer + 1]
    xor     ch,ch
    jcxz    @@SkipMov
    rep movsb
@@SkipMov:
    mov     [BYTE es:di],13      ;add CR

    mov     cl,[KeyInputBuffer + 1]
    add     cl,CLEN
    mov     [UpCMDTail],cl

    mov     bx,offset UPparams
    mov     dx,offset GSZFileName
    call    CallExec

    mov     dx,offset MSG_UploadF
    mov     ah,9
    int     21h

    pop     es ds
    popa
    ret
ENDP
    
    ;Just executes GSZ for a Zmodem download
    
PROC DownLoad NEAR
    push    ds dx es bx ax

    mov     bx,cs
    mov     es,bx
    mov     ds,bx

    mov     dx,offset MSG_DOWNLOAD
    mov     ah,9
    int     21h

    mov     bx,offset DNparams
    mov     dx,offset GSZFileName
    call    CallExec

    mov     dx,offset MSG_DOWNLOADF
    mov     ah,9
    int     21h

    pop     ax bx es dx ds
    ret
ENDP
